config/routes.php
<?php
/**
 * Routes configuration.
 *
 * In this file, you set up routes to your controllers and their actions.
 * Routes are very important mechanism that allows you to freely connect
 * different URLs to chosen controllers and their actions (functions).
 *
 * It's loaded within the context of `Application::routes()` method which
 * receives a `RouteBuilder` instance `$routes` as method argument.
 *
 * CakePHP(tm) : Rapid Development Framework (https://cakephp.org)
 * Copyright (c) Cake Software Foundation, Inc. (https://cakefoundation.org)
 *
 * Licensed under The MIT License
 * For full copyright and license information, please see the LICENSE.txt
 * Redistributions of files must retain the above copyright notice.
 *
 * @copyright     Copyright (c) Cake Software Foundation, Inc. (https://cakefoundation.org)
 * @link          https://cakephp.org CakePHP(tm) Project
 * @license       https://opensource.org/licenses/mit-license.php MIT License
 */

 use Cake\Http\Middleware\CsrfProtectionMiddleware;
use Cake\Routing\Route\DashedRoute;
use Cake\Routing\RouteBuilder;

/*
 * The default class to use for all routes
 *
 * The following route classes are supplied with CakePHP and are appropriate
 * to set as the default:
 *
 * - Route
 * - InflectedRoute
 * - DashedRoute
 *
 * If no call is made to `Router::defaultRouteClass()`, the class used is
 * `Route` (`Cake\Routing\Route\Route`)
 *
 * Note that `Route` does not do any inflections on URLs which will result in
 * inconsistently cased URLs when used with `:plugin`, `:controller` and
 * `:action` markers.
 */
/** @var \Cake\Routing\RouteBuilder $routes */
$routes->setRouteClass(DashedRoute::class);

$routes->scope('/', function (RouteBuilder $builder) {
    $builder->registerMiddleware('csrf', new CsrfProtectionMiddleware([
        'httponly' => true,
    ]));
    // $builder->applyMiddleware('csrf');
    /*
     * Here, we are connecting '/' (base path) to a controller called 'Pages',
     * its action called 'display', and we pass a param to select the view file
     * to use (in this case, templates/Pages/home.php)...
     */
    $builder->connect('/', ['controller' => 'Pokemons', 'action' => 'index', 'home']);

    /*
     * ...and connect the rest of 'Pages' controller's URLs.
     */
    $builder->connect('/pages/*', 'Pages::display');

    /*
     * Connect catchall routes for all controllers.
     *
     * The `fallbacks` method is a shortcut for
     *
     * ```
     * $builder->connect('/:controller', ['action' => 'index']);
     * $builder->connect('/:controller/:action/*', []);
     * ```
     *
     * You can remove these routes once you've connected the
     * routes you want in your application.
     */
    $builder->fallbacks();
});

/*
 * If you need a different set of middleware or none at all,
 * open new scope and define routes there.
 *
 * ```
 * $routes->scope('/api', function (RouteBuilder $builder) {
 *     // No $builder->applyMiddleware() here.
 *     
 *     // Parse specified extensions from URLs
 *     // $builder->setExtensions(['json', 'xml']);
 *     
 *     // Connect API actions here.
 * });
 * ```
 */

src/Model/Entity/Pokemon.php
<?php
declare(strict_types=1);

namespace App\Model\Entity;

use Cake\ORM\Entity;

/**
 * Pokemon Entity
 *
 * @property int $id
 * @property string $name
 * @property int $height
 * @property int $weight
 * @property string $default_front_sprite_url
 * @property \Cake\I18n\FrozenTime $created
 * @property \Cake\I18n\FrozenTime $modified
 * @property int $pokedex_number
 * @property string $default_back_sprite_url
 * @property string $shiny_front_sprite_url
 *
 * @property \App\Model\Entity\PokemonStat[] $pokemon_stats
 * @property \App\Model\Entity\PokemonType[] $pokemon_types
 */
class Pokemon extends Entity
{
    /**
     * Fields that can be mass assigned using newEntity() or patchEntity().
     *
     * Note that when '*' is set to true, this allows all unspecified fields to
     * be mass assigned. For security purposes, it is advised to set '*' to false
     * (or remove it), and explicitly make individual fields accessible as needed.
     *
     * @var array
     */
    protected $_accessible = [
        '*' => true,
        'id' => false,
    ];


    /**
     * Undocumented function
     *
     * @return string
     */
    protected function _getMainSprite()
    {
        return $this->default_front_sprite_url ? $this->default_front_sprite_url : 'unknown.png';
    }


    /**
     * Undocumented function
     *
     * @return string
     */
    protected function _getBackSprite()
    {
        return $this->default_back_sprite_url ? $this->default_back_sprite_url : 'unknown.png';
    }


    /**
     * Undocumented function
     *
     * @return string
     */
    protected function _getShinySprite()
    {
        return $this->shiny_front_sprite_url ? $this->shiny_front_sprite_url : 'unknown.png';
    }

    /**
     * Return the first type for a pokemon
     *
     * @return string
     */
    protected function _getFirstType()
    {
        if (isset($this->pokemon_types) && !empty($this->pokemon_types)) {
            return collection($this->pokemon_types)
                ->extract('type.name')
                ->first();
        }

        return 'normal';
    }

    /**
     * Return the first type for a pokemon
     *
     * @return string
     */
    protected function _getSecondType()
    {
        if (isset($this->pokemon_types) && !empty($this->pokemon_types)) {
            return collection($this->pokemon_types)
                ->extract('type.name')
                ->skip(1)
                ->first();
        }

        return 'normal';
    }

    protected function _getHasSecondType()
    {
        if (isset($this->pokemon_types) && !empty($this->pokemon_types)) {
            return collection($this->pokemon_types)->count() > 1;
        }

        return false;
    }
}

src/Model/Entity/PokemonType.php
<?php
declare(strict_types=1);

namespace App\Model\Entity;

use Cake\ORM\Entity;

/**
 * PokemonType Entity
 *
 * @property int $id
 * @property string $pokemon_id
 * @property string $type_id
 * @property \Cake\I18n\FrozenTime $created
 * @property \Cake\I18n\FrozenTime $modified
 *
 * @property \App\Model\Entity\Pokemon $pokemon
 * @property \App\Model\Entity\Type $type
 */
class PokemonType extends Entity
{
    /**
     * Fields that can be mass assigned using newEntity() or patchEntity().
     *
     * Note that when '*' is set to true, this allows all unspecified fields to
     * be mass assigned. For security purposes, it is advised to set '*' to false
     * (or remove it), and explicitly make individual fields accessible as needed.
     *
     * @var array
     */
    protected $_accessible = [
        '*' => true,
        'id' => false,
    ];
}

src/Model/Table/PokemonsTable.php
<?php
declare(strict_types=1);

namespace App\Model\Table;

use Cake\ORM\Query;
use Cake\ORM\RulesChecker;
use Cake\ORM\Table;
use Cake\Validation\Validator;

/**
 * Pokemons Model
 *
 * @property \App\Model\Table\PokemonStatsTable&\Cake\ORM\Association\HasMany $PokemonStats
 * @property \App\Model\Table\PokemonTypesTable&\Cake\ORM\Association\HasMany $PokemonTypes
 *
 * @method \App\Model\Entity\Pokemon newEmptyEntity()
 * @method \App\Model\Entity\Pokemon newEntity(array $data, array $options = [])
 * @method \App\Model\Entity\Pokemon[] newEntities(array $data, array $options = [])
 * @method \App\Model\Entity\Pokemon get($primaryKey, $options = [])
 * @method \App\Model\Entity\Pokemon findOrCreate($search, ?callable $callback = null, $options = [])
 * @method \App\Model\Entity\Pokemon patchEntity(\Cake\Datasource\EntityInterface $entity, array $data, array $options = [])
 * @method \App\Model\Entity\Pokemon[] patchEntities(iterable $entities, array $data, array $options = [])
 * @method \App\Model\Entity\Pokemon|false save(\Cake\Datasource\EntityInterface $entity, $options = [])
 * @method \App\Model\Entity\Pokemon saveOrFail(\Cake\Datasource\EntityInterface $entity, $options = [])
 * @method \App\Model\Entity\Pokemon[]|\Cake\Datasource\ResultSetInterface|false saveMany(iterable $entities, $options = [])
 * @method \App\Model\Entity\Pokemon[]|\Cake\Datasource\ResultSetInterface saveManyOrFail(iterable $entities, $options = [])
 * @method \App\Model\Entity\Pokemon[]|\Cake\Datasource\ResultSetInterface|false deleteMany(iterable $entities, $options = [])
 * @method \App\Model\Entity\Pokemon[]|\Cake\Datasource\ResultSetInterface deleteManyOrFail(iterable $entities, $options = [])
 *
 * @mixin \Cake\ORM\Behavior\TimestampBehavior
 */
class PokemonsTable extends Table
{
    /**
     * Initialize method
     *
     * @param array $config The configuration for the Table.
     * @return void
     */
    public function initialize(array $config): void
    {
        parent::initialize($config);

        $this->setTable('pokemons');
        $this->setDisplayField('name');
        $this->setPrimaryKey('id');

        $this->addBehavior('Timestamp');

        $this->hasMany('PokemonStats', [
            'foreignKey' => 'pokemon_id',
        ]);
        $this->hasMany('PokemonTypes', [
            'foreignKey' => 'pokemon_id',
        ]);
    }

    /**
     * Default validation rules.
     *
     * @param \Cake\Validation\Validator $validator Validator instance.
     * @return \Cake\Validation\Validator
     */
    public function validationDefault(Validator $validator): Validator
    {
        $validator
            ->integer('id')
            ->allowEmptyString('id', null, 'create');

        $validator
            ->scalar('name')
            ->maxLength('name', 255)
            ->requirePresence('name', 'create')
            ->notEmptyString('name');

        $validator
            ->integer('height')
            ->requirePresence('height', 'create')
            ->notEmptyString('height');

        $validator
            ->integer('weight')
            ->requirePresence('weight', 'create')
            ->notEmptyString('weight');

        $validator
            ->scalar('default_front_sprite_url')
            ->maxLength('default_front_sprite_url', 255)
            ->requirePresence('default_front_sprite_url', 'create')
            ->notEmptyString('default_front_sprite_url');

        $validator
            ->integer('pokedex_number')
            ->requirePresence('pokedex_number', 'create')
            ->notEmptyString('pokedex_number');

        $validator
            ->scalar('default_back_sprite_url')
            ->maxLength('default_back_sprite_url', 255)
            ->requirePresence('default_back_sprite_url', 'create')
            ->notEmptyString('default_back_sprite_url');

        $validator
            ->scalar('shiny_front_sprite_url')
            ->maxLength('shiny_front_sprite_url', 255)
            ->requirePresence('shiny_front_sprite_url', 'create')
            ->notEmptyString('shiny_front_sprite_url');

        return $validator;
    }

    /**
     * Format Data for save
     *
     * @param array $pokeApiData Data from Poke Api
     * @return array
     */
    public function formatDataForSave($pokeApiData)
    {
        $pokemonStats = $this->PokemonStats->formatDataForSave($pokeApiData['stats']);
        $pokemonTypes = $this->PokemonTypes->formatDataForSave($pokeApiData['types']);

        return [
            'pokedex_number' => $pokeApiData['id'],
            'name' => $pokeApiData['name'],
            'default_front_sprite_url' => ($pokeApiData['sprites']['front_default'] ? $pokeApiData['sprites']['front_default'] : 'unknown.png'),
            'default_back_sprite_url' => ($pokeApiData['sprites']['back_default'] ? $pokeApiData['sprites']['back_default'] : 'unknown.png'),
            'shiny_front_sprite_url' => ($pokeApiData['sprites']['front_shiny'] ? $pokeApiData['sprites']['front_shiny'] : 'unknown.png'),
            'height' => $pokeApiData['height'],
            'weight' => $pokeApiData['weight'],
            'pokemon_stats' => $pokemonStats,
            'pokemon_types' => $pokemonTypes,
            'generation' => $pokeApiData['generation'],
        ];
    }
}

src/Controller/PokemonsController.php
<?php
declare(strict_types=1);

namespace App\Controller;

use Cake\ORM\TableRegistry;

/**
 * Pokemons Controller
 *
 * @property \App\Model\Table\PokemonsTable $Pokemons
 * @method \App\Model\Entity\Pokemon[]|\Cake\Datasource\ResultSetInterface paginate($object = null, array $settings = [])
 */
class PokemonsController extends AppController
{
    /**
     * Index method
     *
     * @return \Cake\Http\Response|null|void Renders view
     */
    public function index()
    {
        $this->paginate = [
            'limit' => 30,
        ];

        $pokemons = $this->Pokemons->find('all')->contain(['PokemonStats.Stats', 'PokemonTypes.Types'])->order(["pokedex_number" => "ASC"]);
        $pokemons = $this->paginate($pokemons);

        $this->set(compact('pokemons'));
    }

    /**
     * View method
     *
     * @param string|null $id Pokemon id.
     * @return \Cake\Http\Response|null|void Renders view
     * @throws \Cake\Datasource\Exception\RecordNotFoundException When record not found.
     */
    public function view($id = null)
    {
        $pokemon = $this->Pokemons->get($id, [
            'contain' => ['PokemonStats.Stats', 'PokemonTypes.Types'],
        ]);
        
        $statsName = $this->getTableLocator()->get('stats')->find()->all()->combine("id","name")->toArray();
        $typeName = $this->getTableLocator()->get('types')->find()->all()->combine("id","name")->toArray();


        $this->set(compact('typeName'));
        $this->set(compact('statsName'));
        $this->set(compact('pokemon'));
    }

    /**
     * Delete method
     *
     * @param string|null $id Pokemon id.
     * @return \Cake\Http\Response|null|void Redirects to index.
     * @throws \Cake\Datasource\Exception\RecordNotFoundException When record not found.
     */
    public function delete($id = null)
    {
        $this->request->allowMethod(['post', 'delete']);
        $pokemon = $this->Pokemons->get($id);
        if ($this->Pokemons->delete($pokemon)) {
            $this->Flash->success(__('The pokemon has been deleted.'));
        } else {
            $this->Flash->error(__('The pokemon could not be deleted. Please, try again.'));
        }

        return $this->redirect(['action' => 'index']);
    }

    public function dashboard()
    {
        $pokemons = TableRegistry::getTableLocator()->get('pokemons');

        //Requete pour le poid moyen
        $weights = $pokemons->find();
        $weights->select(['poidsMoyen' => $weights->func()->avg('weight')])->where(['generation =' => 4]);

        $poidsMoyen = $weights->first();

        /**Recherche dans la base de donnée le nombre de pokémon de type fée par génération */
        function fairy($generation)
        {
            $pokemons = TableRegistry::getTableLocator()->get('pokemons');
            $fairy = $pokemons->find()->Join('pokemon_types')->Join('types');
            $fairy->select(['Nb_Type_Fee' => $fairy->func()->count('*')])
            ->where(['types.name =' => 'fairy'])
            ->andwhere(['pokemon_types.type_id = types.id'])
            ->andwhere(['pokemons.id = pokemon_types.pokemon_id'])
            ->andwhere(['pokemons.generation = ' => $generation]);

            return $fairy->first();
        }

        //choix des génération pour les types fée
        $generation = [1, 3, 7];
        $NombreTypeFee_1 = fairy($generation[0]);
        $NombreTypeFee_3 = fairy($generation[1]);
        $NombreTypeFee_7 = fairy($generation[2]);
        $NombreTypeFee = $NombreTypeFee_1->Nb_Type_Fee + $NombreTypeFee_3->Nb_Type_Fee + $NombreTypeFee_7->Nb_Type_Fee;

        //requete pour les 10 pokémons les plus rapide
        $speed = $pokemons->find()->Join('pokemon_stats')->Join('stats');
        $speed->select(['pokemon_stats.value', 'pokemons.name', 'pokemons.id', 'pokemons.default_front_sprite_url'])
        ->where(['stats.name =' => 'speed'])
        ->andwhere(['pokemon_stats.stat_id = stats.id'])
        ->andwhere(['pokemons.id = pokemon_stats.pokemon_id'])
        ->order(['pokemon_stats.value' => 'DESC'])
        ->limit(10);

        $speeder = $speed->all();

        $this->set(compact('poidsMoyen'));
        $this->set(compact('generation'));
        $this->set(compact('NombreTypeFee'));
        $this->set(compact('NombreTypeFee_1'));
        $this->set(compact('NombreTypeFee_3'));
        $this->set(compact('NombreTypeFee_7'));
        $this->set(compact('speeder'));
    }
}

templates/Pokemons/dashboard.php
<br></br>
<h3>Poids Moyen</h3>
<table>
    <tr>
        <th>Génération</th>
        <th>Poids Moyen</th>
    </tr>
    <tr>
        <th>4</th>
        <td><?= h($poidsMoyen->poidsMoyen) ?></td>
    </tr>
</table>
<br></br>
<h3>Nombre de Pokémons de type Fée</h3>
<table>
    <tr>
        <th>Génération</th>
        <th>Nombre de type fée</th>
    </tr>
    
    <tr>
        <th><?= h($generation[0]) ?></th>
        <td><?= h($NombreTypeFee_1->Nb_Type_Fee) ?></td>
    </tr>
    <tr>
    <th><?= h($generation[1]) ?></th>
        <td><?= h($NombreTypeFee_3->Nb_Type_Fee) ?></td>
    </tr>
    <tr>
    <th><?= h($generation[2]) ?></th>
        <td><?= h($NombreTypeFee_7->Nb_Type_Fee) ?></td>
    </tr>
    <tr>
        <th>TOTAL</th>
        <th><?= h($NombreTypeFee) ?></th>
    </tr>
</table>
<br></br>
<h3>Les 10 pokémons les plus rapides</h3>
<table>
    <tr>
        <th>Pokémon</th>
        <th>Vitesse</th>       
    </tr>
    <?php foreach ($speeder as $pokemon) : ?>
    <tr>
        <td><?= $this->Html->image($pokemon->default_front_sprite_url, ["width" => 96, "height" => 96, "url" => ['action' => 'view', $pokemon->id]]); ?> <?= $this->Html->link(__($pokemon->name), ['action' => 'view', $pokemon->id]) ?></td>
        <td><?= h($pokemon->pokemon_stats['value']) ?></td>
    </tr>
    <?php endforeach; ?>
</table>

templates/Pokemons/index.php
<?php
/**
 * @var \App\View\AppView $this
 * @var \App\Model\Entity\Pokemon[]|\Cake\Collection\CollectionInterface $pokemons
 */
?>
<div class="pokemons index content">
    <h3><?= __('Pokemons') ?></h3>

    <div class="row">
        <?php foreach ($pokemons as $pokemon) : ?>
                <div class="col-12 col-md-4 col-sm-6 col-xs-12">
                    <?= $this->element('Pokemons/card', ['pokemon' => $pokemon]); ?>
                </div>
        <?php endforeach; ?>
    </div>
    <div class="paginator">
        <ul class="pagination">
            <?= $this->Paginator->first('<< ' . __('first')) ?>
            <?= $this->Paginator->prev('< ' . __('previous')) ?>
            <?= $this->Paginator->numbers() ?>
            <?= $this->Paginator->next(__('next') . ' >') ?>
            <?= $this->Paginator->last(__('last') . ' >>') ?>
        </ul>
        <p><?= $this->Paginator->counter(__('Page {{page}} of {{pages}}, showing {{current}} record(s) out of {{count}} total')) ?></p>
    </div>
</div>

templates/Pokemons/view.php
<?php
/**
 * @var \App\View\AppView $this
 * @var \App\Model\Entity\Pokemon $pokemon
 */
?>
<div class="row">
    <aside class="column">
        <div class="side-nav">
        </div>
    </aside>
    <div class="column-responsive column-80">
        <div class="pokemons view contentCARTE">
            <h3 class="carte"><?= h($pokemon->name) ?></h3>
            <div class="imgpokeport">
                    <?= $this->Html->image($pokemon->main_sprite, ["class" => "img-thumbnail"]); ?>
            </div>
            <div class="responsive">
                <?php if (!empty($pokemon->pokemon_types)) : ?>
                <div class="responsive">
                    <table>
                        <?php foreach ($pokemon->pokemon_types as $pokemonTypes) : ?>
                            <span class="responsive card--<?= h($typeName[$pokemonTypes->type_id]) ?>"><?= h($typeName[$pokemonTypes->type_id]) ?></span>
                        <?php endforeach; ?>
                    </table>
                </div>
                <?php endif; ?>
            </div>
            <div class="related">
                <?php if (!empty($pokemon->pokemon_stats)) : ?>
                <div class="table-responsive">
                    <table>
                        <?php foreach ($pokemon->pokemon_stats as $pokemonStats) : ?>
                        <tr>
                            <td><?= h(preg_replace("/-/", " ", $statsName[$pokemonStats->stat_id])) ?></td>
                            <td><?= h($pokemonStats->value) ?></td>
                        </tr>
                        <?php endforeach; ?>
                    </table>
                </div>
                <?php endif; ?>
            </div>
            <div class="ca">
            <div id="myCarousel" class="carousel slide" data-ride="carousel">
                <div class="carousel-inner">
                    <div class="carousel-item active">
                    <?= $this->Html->image($pokemon->main_sprite, ["class" => "d-block w-100"]); ?>
                    </div>
                    <div class="carousel-item">
                    <?= $this->Html->image($pokemon->back_sprite, ["class" => "d-block w-100"]); ?>
                    </div>
                    <div class="carousel-item">
                    <?= $this->Html->image($pokemon->shiny_sprite, ["class" => "d-block w-100"]); ?>
                    </div>
                </div>
                <a class="carousel-control-prev" href="#myCarousel" role="button" data-slide="prev">
                    <span class="carousel-control-prev-icon" aria-hidden="true"></span>
                    <!-- <span class="sr-only">Previous</span> -->
                </a>
                <a class="carousel-control-next" href="#myCarousel" role="button" data-slide="next">
                    <span class="carousel-control-next-icon" aria-hidden="true"></span>
                    <!-- <span class="sr-only">Next</span> -->
                </a>
            </div>
            <div>
            <script src="https://code.jquery.com/jquery-3.2.1.slim.min.js" integrity="sha384-KJ3o2DKtIkvYIK3UENzmM7KCkRr/rE9/Qpg6aAZGJwFDMVNA/GpGFF93hXpG5KkN" crossorigin="anonymous"></script>
            <script src="https://cdnjs.cloudflare.com/ajax/libs/popper.js/1.12.9/umd/popper.min.js" integrity="sha384-ApNbgh9B+Y1QKtv3Rn7W3mgPxhU9K/ScQsAP7hUibX39j7fakFPskvXusvfa0b4Q" crossorigin="anonymous"></script>
            <script src="https://maxcdn.bootstrapcdn.com/bootstrap/4.0.0/js/bootstrap.min.js" integrity="sha384-JZR6Spejh4U02d8jOt6vLEHfe/JQGiRRSQQxSfFWpi1MquVdAyjUar5+76PVCmYl" crossorigin="anonymous"></script>
        </div>
    </div>
</div>